/*
 * main.c
 *
 *  Created on: Feb 22, 2009
 *      Author: mike
 */

# define F_CPU 8000000UL
#define BAUD 9600
#define MYUBRR F_CPU/16/BAUD-1

#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"

unsigned char write_to_line = 0;

unsigned char buffer[16] = {
		"   RSS Reader   "
};

void write_buffer(void)
{
	lcd_gotoxy(0,write_to_line);
	for (unsigned char i=0; i<16; i++)
	{
		lcd_putc(buffer[i]);
	}
}

void add_to_buffer(unsigned char new_char)
{
	//Shift all buffered chars up one index
	for (unsigned char i=1; i<16; i++)
	{
		buffer[i-1] = buffer[i];
	}
	buffer[15] = new_char;
}

void clear_buffer(void)
{
	for (unsigned char i=0; i<16; i++)
	{
		buffer[i] = ' ';
	}
}

void USART_Init( unsigned int ubrr)
{
  /* Set baud rate */
  UBRRH = (unsigned char)(ubrr>>8);
  UBRRL = (unsigned char)ubrr;
  /* Enable receiver and transmitter */
  UCSRB = (1<<RXEN)|(1<<TXEN);
  /* Set frame format: 8data, 2stop bit */
  UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
}

void USART_Transmit( unsigned char data )
{
  /* Wait for empty transmit buffer */
  while ( !( UCSRA & (1<<UDRE)) )
       ;
  /* Put data into buffer, sends the data */
  UDR = data;
}

unsigned char USART_Receive( void )
{
  /* Wait for data to be received */
  while ( !(UCSRA & (1<<RXC)) )
       ;
  /* Get and return received data from buffer */
  return UDR;
}


int main(void)
{
	USART_Init ( MYUBRR );

	lcd_init(LCD_DISP_ON);  //Initialize LCD with the cursor off

	lcd_clrscr();           //Clear the LCD screen
	  //lcd_gotoxy(5,0);        //Move cursor to this location
	  //lcd_puts("Dragon");     //Put this string on the LCD

	write_buffer();
	unsigned char myChar;
	while(1)
  {
		myChar = USART_Receive();
		switch (myChar)
		{
			case 0x00:
			{
				lcd_clrscr();
				clear_buffer();
				break;
			}
			case 0x01:
			{
				write_to_line = 0;
				clear_buffer();
				break;
			}
			case 0x02:
			{
				write_to_line = 1;
				clear_buffer();
				break;
			}
			default:
			{
				add_to_buffer(myChar);
				write_buffer();
			}
		}
  }
}
