rss_urls = (
	('Slashdot', 'http://rss.slashdot.org/Slashdot/slashdot'),
	('Digg', 'http://feeds.digg.com/digg/popular.rss'),
	('NY Times', 'http://www.nytimes.com/services/xml/rss/nyt/HomePage.xml')
	)
charDelay = 0.2 #Seconds to delay before pringing next character.

import urllib
from xml.dom import minidom, Node
import serial
import time
import unicodedata

#setup RS232 communitcations protocol
ser = serial.Serial(0, 9600, stopbits=2)

def serialize_string(myString):
    for char in range(len(myString)):
        #Write the next character in the string
        ser.write(myString[char])
        #Pause for scrolling effect
        time.sleep(charDelay)

def write_title(myTitle):
        ser.write(chr(0x00)) #clear lcd
        ser.write(chr(0x01)) #tell lcd to write to line 0
        #Write title so that it is left-aligned (on 16 character display)
        for i in range(16):
            if i < len(myTitle):
                ser.write(myTitle[i])
            else:
                ser.write(' ')

def parse_feed(RSS_URL):
    url_info = urllib.urlopen(RSS_URL)
    xmldoc = minidom.parse(url_info)
    item_list = xmldoc.getElementsByTagName('item')

    for item in range(item_list.length):
        titles = item_list[item].getElementsByTagName('title')
        for title in range(titles.length):
            for children in range(titles[title].childNodes.length):
                #serialize_string(str(titles[title].childNodes[children].nodeValue))
                myTitle = titles[title].childNodes[children].nodeValue
                myTitle = unicodedata.normalize('NFKD', myTitle).encode('ascii','replace')
                serialize_string(myTitle)
                serialize_string(' --- ')
                #print titles[title].childNodes[children].nodeValue

while 1:
    for feed in range(len(rss_urls)):
        write_title(str(rss_urls[feed][0]))
        ser.write(chr(0x02)) #tell lcd to write to line 1
        parse_feed(rss_urls[feed][1])
